package com.ar.act;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.view.Window;

/**
 * 魅族
 * @author Administrator
 *
 */
public class BaseActivity extends Activity {

	BaseActivity mSelfAct;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// 隐藏标题
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		mSelfAct = this;
	}

	@Override
	protected void onPause() {
		super.onPause();
		unregisterListener();
		App.getInstance().showTime--;
		App.getInstance().stopLocation();
	}

	@Override
	protected void onResume() {
		super.onResume();
		if (App.getInstance().phoneQualit == 1) {
			sensor = SensorManager.SENSOR_DELAY_GAME;
		} else {
			sensor = SensorManager.SENSOR_DELAY_UI;
			maxTimes = 20;
		}
		if (mSensorManager != null) {
			mSensorManager.registerListener(listener,
					mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER),
					sensor);
			mSensorManager
					.registerListener(listener, mSensorManager
							.getDefaultSensor(Sensor.TYPE_MAGNETIC_FIELD),
							sensor);
		}
		App.getInstance().showTime++;
		App.getInstance().startLocation();
	};

	// ************************方向感應***********************
	private SensorManager mSensorManager;
	private SensorListener mSensorListener;
	private int sensor = SensorManager.SENSOR_DELAY_UI;

	protected void onStartSensor(SensorListener mSensorListener) {
		if (mSensorListener != null) {
			this.mSensorListener = mSensorListener;
			mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);

		}
	}

	protected void unregisterListener() {
		if (mSensorManager != null) {
			mSensorManager.unregisterListener(listener);
		}
	}

	// 15ms一次
	private int time;
	private int maxTimes = 30;

	float[] accelerometerValues = new float[3];
	float[] magneticFieldValues = new float[3];
	float[] values = new float[3];
	float[] rotate = new float[9];

	private final SensorEventListener listener = new SensorEventListener() {

		@Override
		public void onAccuracyChanged(Sensor sensor, int accuracy) {
//			System.out.println(accuracy + "......................");
		}

		@Override
		public void onSensorChanged(SensorEvent event) {

			if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
				accelerometerValues[0] = event.values[0];
				accelerometerValues[1] = event.values[1];
				accelerometerValues[2] = event.values[2];
			}
			if (event.sensor.getType() == Sensor.TYPE_MAGNETIC_FIELD) {
				magneticFieldValues[0] = event.values[0];
				magneticFieldValues[1] = event.values[1];
				magneticFieldValues[2] = event.values[2];
			}

			SensorManager.getRotationMatrix(rotate, null, accelerometerValues,
					magneticFieldValues);
			SensorManager.getOrientation(rotate, values);
			// 经过SensorManager.getOrientation(rotate, values);得到的values值为弧度
			// 转换为角度
			values[0] = (float) Math.toDegrees(values[0]);
			values[1] = (float) Math.toDegrees(values[1]);
			values[2] = (float) Math.toDegrees(values[2]);

			if (values[0] < 0) {
				values[0] += 360;
			}
			values[2] = -values[2];

			if (Math.abs(values[2]) > 90) {
				values[0] = values[0] - 180;
				values[1] = -180 - values[1];
			}
			if (values[0] < 0) {
				values[0] += 360;
			}

			mSensorListener.XAngle(values[0]);
			mSensorListener.YAngle(values[1]);
			mSensorListener.ZAngle(values[2]);

//			System.out.println(values[0] + "      " + values[1] + "      "
//					+ values[2]);

			// // 获取触发event的传感器类型
			// int sensorType = event.sensor.getType();
			//
			// switch (sensorType) {
			// case Sensor.TYPE_ORIENTATION:
			// mSensorListener.XAngle(event.values[SensorManager.DATA_X]);
			// mSensorListener.YAngle(event.values[SensorManager.DATA_Y]);
			// mSensorListener.ZAngle(event.values[SensorManager.DATA_Z]);
			// break;
			//
			// // 加速度
			// // case Sensor.TYPE_ACCELEROMETER:
			// // // 图解中已经解释三个值的含义
			// // float x = event.values[0];
			// // float y = event.values[1];
			// // float z = event.values[2];
			// // // 左横屏
			// // if (x > 8) {
			// // time++;
			// // if (time >= maxTimes) {
			// // time = 0;
			// // mSensorListener.landscapeLeft();
			// // }
			// // } else
			// // // 右横屏
			// // if (x < -8) {
			// // time++;
			// // if (time >= maxTimes) {
			// // time = 0;
			// // mSensorListener.landscapeRight();
			// // }
			// // } else
			// // // 竖屏
			// // if (Math.abs(x) < 3 && y > 7) {
			// // time++;
			// // if (time >= maxTimes) {
			// // time = 0;
			// // mSensorListener.portrait();
			// // }
			// // } else
			// // // 水平放置
			// // if (Math.abs(x) < 3 && Math.abs(y) < 3 && z > 8) {
			// // time++;
			// // if (time >= maxTimes) {
			// // time = 0;
			// // mSensorListener.horizontal();
			// // }
			// // } else {
			// // time = 0;
			// // }
			// // break;
			//
			// }
			// 图解中已经解释三个值的含义
			float y = values[1];
			float z = values[2];
			// 竖屏
			if (y < -60 && y > -120 && Math.abs(z) < 15) {
				time++;
				if (time >= maxTimes) {
					time = 0;
					mSensorListener.portrait();
				}
			} else
			// 水平放置
			if (Math.abs(y) < 15 && Math.abs(z) < 15) {
				time++;
				if (time >= maxTimes) {
					time = 0;
					mSensorListener.horizontal();
				}
			} else
			// 左旋转横屏
			if (z > 60) {
				time++;
				if (time >= maxTimes) {
					time = 0;
					mSensorListener.landscapeLeft();
				}
			} else
			// 右旋转横屏
			if (z < -60) {
				time++;
				if (time >= maxTimes) {
					time = 0;
					mSensorListener.landscapeRight();
				}
			} else {
				time = 0;
			}

		}
	};

	interface SensorListener {
		// 水平角度
		void XAngle(float value);

		// 垂直角度
		void YAngle(float value);

		// 翻转角度
		void ZAngle(float value);

		// 左旋转横屏
		void landscapeLeft();

		// 右旋转横屏
		void landscapeRight();

		// 竖屏
		void portrait();

		// 平放
		void horizontal();
	}

}
